<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfLinhasComprasTransERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfLinhasComprasTransERP
 * @subpackage Arrays
 */
class ArrayOfLinhasComprasTransERP extends AbstractStructArrayBase
{
    /**
     * The LinhasComprasTransERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\LinhasComprasTransERP[]
     */
    public $LinhasComprasTransERP;
    /**
     * Constructor method for ArrayOfLinhasComprasTransERP
     * @uses ArrayOfLinhasComprasTransERP::setLinhasComprasTransERP()
     * @param \StructType\LinhasComprasTransERP[] $linhasComprasTransERP
     */
    public function __construct(array $linhasComprasTransERP = array())
    {
        $this
            ->setLinhasComprasTransERP($linhasComprasTransERP);
    }
    /**
     * Get LinhasComprasTransERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\LinhasComprasTransERP[]|null
     */
    public function getLinhasComprasTransERP()
    {
        return isset($this->LinhasComprasTransERP) ? $this->LinhasComprasTransERP : null;
    }
    /**
     * Set LinhasComprasTransERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\LinhasComprasTransERP[] $linhasComprasTransERP
     * @return \ArrayType\ArrayOfLinhasComprasTransERP
     */
    public function setLinhasComprasTransERP(array $linhasComprasTransERP = array())
    {
        foreach ($linhasComprasTransERP as $arrayOfLinhasComprasTransERPLinhasComprasTransERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfLinhasComprasTransERPLinhasComprasTransERPItem instanceof \StructType\LinhasComprasTransERP) {
                throw new \InvalidArgumentException(sprintf('The LinhasComprasTransERP property can only contain items of \StructType\LinhasComprasTransERP, "%s" given', is_object($arrayOfLinhasComprasTransERPLinhasComprasTransERPItem) ? get_class($arrayOfLinhasComprasTransERPLinhasComprasTransERPItem) : gettype($arrayOfLinhasComprasTransERPLinhasComprasTransERPItem)), __LINE__);
            }
        }
        if (is_null($linhasComprasTransERP) || (is_array($linhasComprasTransERP) && empty($linhasComprasTransERP))) {
            unset($this->LinhasComprasTransERP);
        } else {
            $this->LinhasComprasTransERP = $linhasComprasTransERP;
        }
        return $this;
    }
    /**
     * Add item to LinhasComprasTransERP value
     * @throws \InvalidArgumentException
     * @param \StructType\LinhasComprasTransERP $item
     * @return \ArrayType\ArrayOfLinhasComprasTransERP
     */
    public function addToLinhasComprasTransERP(\StructType\LinhasComprasTransERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\LinhasComprasTransERP) {
            throw new \InvalidArgumentException(sprintf('The LinhasComprasTransERP property can only contain items of \StructType\LinhasComprasTransERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->LinhasComprasTransERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\LinhasComprasTransERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\LinhasComprasTransERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\LinhasComprasTransERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\LinhasComprasTransERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\LinhasComprasTransERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string LinhasComprasTransERP
     */
    public function getAttributeName()
    {
        return 'LinhasComprasTransERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfLinhasComprasTransERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
